Unit ftflc_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, FTF1C_p;

procedure ftflc(var ARE :Array of Real; var AIM :Array of Real;
                var N :Integer; L :Integer; M :Integer; var P :Real;
                var XRE :Array of Real; var XIM :Array of Real);

implementation

procedure ftflc(var ARE :Array of Real; var AIM :Array of Real;
                var N :Integer; L :Integer; M :Integer; var P :Real;
                var XRE :Array of Real; var XIM :Array of Real);
var
I,J,K,JN,JJ,JK :Integer;
Q,T,C,S,CO,SI,RR,RI :Real;
label
_1,_2,_3;
begin
K := Trunc( N/L );
JJ := Trunc( M*L-1 );
JK := 0;
for I:=1 to K do
 begin
_1:
  FTF1C(ARE,AIM,N,I,K,P);
 end;
Q := -2.0*P/(N);
for I:=1 to L do
 begin
  T := Q*(I+JJ);
  C := Cos(T);
  S := Sin(T);
  CO := C;
  SI := S;
  JN := JK+1;
  RR := ARE[JN-1];
  RI := AIM[JN-1];
  JN := JN+1;
  JK := JK+K;
  for J:=JN to JK do
   begin
    RR := RR+ARE[J-1]*CO-AIM[J-1]*SI;
    RI := RI+AIM[J-1]*CO+ARE[J-1]*SI;
    T := C*CO-S*SI;
    SI := C*SI+S*CO;
_2:
    CO := T;
   end;
  XRE[I-1] := RR;
_3:
  XIM[I-1] := RI;
 end;
end;

end.
